# basic_classes.R

# chapter 3
# chapter 6 pages 82-91

# Creating variables of different classes
numeric_value <- 52.50 # Numeric (decimal number) Class
integer_value <- 52L # Integer (whole, int) Class
text_value <- "Hello" # Character (text) Class
boolean_value <- TRUE # Logical (boolean T/F) Class
date_value <- as.Date("2025-02-20") # Date Class

fName <- "Bob" # ['B','o','b'] "String"

# How do we check to see what class we are using
class(fName) # Character Class

# Conversions between dissimilar classes
# as keyword to covert objects (class)
num_x <- 7 # Integer
class(num_x)

# LBYL vs EAFP Principle
# LBYL if
# EAFP try/except OOP
# Look before You Leap
# Easier to Ask for Forgiveness than Permission

result <- is.character(num_x) # True/False LBYL
# use an if

# Convert to a char
char_x <- as.character(num_x) # test AND conversion
print(char_x)
class(char_x)

# value -> arg/param -> functions -> data sets -> return

# "Bob" "Joe" "Mary" !structural but organize values
## firstNames <- c("Bob","Joe","Mary")
# values group category "factoral"  factor()
fNames <- factor(
  c("Bob","Joe","Mary")
) # fNames Category of char sets categorical data

# List Class -> dissimilar data types
student <- list(
  name = "Bob Jones",
  age = 21,
  scholorships = TRUE,
  enrolled_classes = c("Math", "Science", "Athletics")
) # student

print(student$name)

# EOF basic_classes.R