# simple_analysis.R
# pages 39-45 collection of independents
# pages 70-76 independents -> data frames

# Create some scoring data
first_names <- c("Bob","Joe","Mary") # ' " quotes
# data frame "rectangular" data frame
math_scores <- c(85, 92, 85)
science_scores <- c(92, 84, 81)

print(first_names)


# Create a data frame "dependent data" from the 3 collections

df_scores <- data.frame(
  Name = first_names, # col A label Name data first_names
  MathScores = math_scores, # col b
  ScienceScores = science_scores # col c
) # df_scores



# Data Analysis -> aggregates / stats / geo / trig/ calcs
## sum(), avg(mean), stddev(), min(), max(), floor(), ceil(), median(), count(), sin(), cos(), tan(), log()

# Calculate average
# Series or a column named Average as col D
df_scores$Average <- (
  df_scores$MathScores + df_scores$ScienceScores
) / 2 # Average

print(df_scores)

# You can use data from a data frame and assign it to a variable
## get the max() score from the df for the Math Series
max_MathScore <- max(df_scores$MathScores)

# print a report that has the max score
## ex: ('H',ighest Math Score: ) ('9','5')
## type: string + int  ? error  "7" + 3 error
## Law of Demeter (string, int) 
print(
  paste(
    "Highest Math Score: ", max(df_scores$MathScores)
  ) # (string) -> char() (int) -> char()
) # print

# select all records from tbl_contacts where state = "FL"
# `SELECT * from 'tbl_contacts where state = "FL" ' `
# from the df, Find WHICH NAME has the MAX AVERAGE
find_max_name <- df_scores$Name[
  which.max(
    df_scores$Average
    )
  ] # df_scores

print(
  paste(
    find_max_name, "has the best average score." 
  )
)



# EOF simple_analysis.R